// Saturation
// N₩̕ύX
unit Saturation_Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs, system.Types,
  system.Math, system.UITypes;

type
  TForm1 = class(TForm)
    FileOpen: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    ScrollBox1: TScrollBox;
    Image2: TImage;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    SaturationBtn: TButton;
    LabeledEdit1: TLabeledEdit;
    SavePictureDialog1: TSavePictureDialog;
    FileeSaveBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SaturationBtnClick(Sender: TObject);
    procedure FileeSaveBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray = ^TPrgbarry;                     // |C^[
                                              // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B
const
// t@Cgqݒ
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

// Kvϐ̐錾
var
  InBitmap        : TBitmap;                  // rbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : integer;                  // \[X摜TCY

//***************************************************************************
// N₩̒
// R = Rin * sat + Gin * (1 - sat) / 2 + Bin * (1 - sat) / 2     Wv@1
// G = Rin * (1 - sat) / 2 + Gin * sat + Bin * (1 - sat) / 2     Wv@1
// B = Rin * (1 - sat) / 2 + Gin * (1 - sat) / 2 + Bin * sat     Wv@1
//     Wv 1           Wv 1          Wv 1
// syї̒W̍vPɂȂ悤ɐݒ肵܂
//***************************************************************************
procedure TForm1.SaturationBtnClick(Sender: TObject);
var
  X, Y          : Integer;
  Pin, Pout     : Prgbarray;
  Rin, Gin, Bin : Smallint;
  R, G, B       : Smallint;
  sat, mst      : Double;             // ؂₩W
begin
  Val(LabeledEdit1.Text, sat, X);     // N₩W
  if X <> 0 then begin
    Application.MessageBox('͒l͐lł͂܂','N₩W',0);
    exit;
  end;
  mst := (1 - sat) / 2;                  // ␳WvZ
  for Y := 0 to GHeight - 1 do begin
    Pin  := InBitmap.ScanLine[Y];
    Pout := OutBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      Bin := pin[X].rgbtBlue;
      Gin := pin[X].rgbtGreen;
      Rin := pin[X].rgbtRed;
      B := Round(Bin * sat + Gin * mst + Rin * mst);
      G := Round(Bin * mst + Gin * sat + Rin * mst);
      R := Round(Bin * mst + Gin * mst + Rin * sat);
      if R < 0 then R := 0;
      if G < 0 then G := 0;
      if B < 0 then B := 0;
      if R > 255 then R := 255;
      if G > 255 then G := 255;
      if B > 255 then B := 255;
      Pout[X].rgbtBlue  := B;
      Pout[X].rgbtGreen := G;
      Pout[X].rgbtRed   := R;
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;                    // 摜\
  FileeSaveBtn.Enabled  := True;
end;

//************************************************************
// t@C̃I[v@WIC@t@C̎ނ̂Ŏgp
//************************************************************
procedure TForm1.FileOpenClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜擾
        InBitmap.Width    := GWidth;
        InBitmap.Height   := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        OutBitmap.Width   := GWidth;                          // o͉摜
        OutBitmap.Height  := GHeight;                         // o͉摜
        image1.Picture.Bitmap := InBitmap;                    // 摜\
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  SaturationBtn.Enabled := True;
end;

//*************************************************************************
// TWICImage gpăt@Cۑ
// XE3, XE4 ł́A[[N܂
//*************************************************************************
procedure TForm1.FileeSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;                             // t@CZ[utB^[̐ݒ
  if not SavePictureDialog1.Execute then exit;                             // t@Cݒ肳ĂȂ炱܂
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;                                  // gq
  ExeStr := ExtractFileExt(Fname);
  if not WFormatSet then begin
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);
  if Length(FnameTop) = Length(ExeStr) then begin
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;
  try
    WIC.Assign(OutBitmap);
    WIC.ImageFormat := WICF;
    WIC.SaveTofile(Fname);                 // XE3,XE4 ł̓[[N܂B
  finally                                  // AV[v}XLOQƂĉB
    WIC.Free;
  end;
end;

//*********************
// ݒ
//*********************
procedure TForm1.FormCreate(Sender: TObject);
begin
  Top := (Screen.Height - Height) div 2;                      // \ʒuݒ
  Left := (Screen.Width - Width) div 2;
  InBitmap      := TBitmap.Create;                            // ͉摜p
  OutBitmap     := TBitmap.Create;                            // o͉摜p
  InBitmap.PixelFormat    := pf24bit;                         // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf24bit;                         // 24rbgJ[ɐݒ
  SaturationBtn.Enabled := False;
  FileeSaveBtn.Enabled  := False;
end;

//**********************
// rbg}bv̉@
//**********************
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
